(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@ng-bootstrap/ng-bootstrap'), require('moment'), require('inputmask'), require('@ng-select/ng-select'), require('nouislider'), require('wnumb')) :
    typeof define === 'function' && define.amd ? define('@spotsoftware/angular-components', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@ng-bootstrap/ng-bootstrap', 'moment', 'inputmask', '@ng-select/ng-select', 'nouislider', 'wnumb'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.spotsoftware = global.spotsoftware || {}, global.spotsoftware['angular-components'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.ngBootstrap, global.moment, global.inputmask, global.ngSelect, global.nouislider, global.wnumb));
}(this, (function (exports, core, common, forms, ngBootstrap, momentNs, Inputmask, ngSelect, nouislider, wNumb) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var momentNs__namespace = /*#__PURE__*/_interopNamespace(momentNs);
    var Inputmask__default = /*#__PURE__*/_interopDefaultLegacy(Inputmask);
    var wNumb__default = /*#__PURE__*/_interopDefaultLegacy(wNumb);

    var nextId$2 = 0;
    var CheckboxComponent = /** @class */ (function () {
        function CheckboxComponent(cd) {
            this.cd = cd;
            this.value = false;
            this.isDisabled = false;
            this.id = "chk-" + nextId$2++;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        CheckboxComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.cd.markForCheck();
        };
        CheckboxComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        CheckboxComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        CheckboxComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        CheckboxComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        CheckboxComponent.prototype.ngOnInit = function () {
        };
        CheckboxComponent.prototype.onModelChange = function () {
            this.propagateChange(this.value);
            this.onTouched();
        };
        return CheckboxComponent;
    }());
    CheckboxComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-checkbox',
                    template: "<div class=\"form-check\">\r\n    <input type=\"checkbox\" [disabled]=\"isDisabled\" id=\"{{ 'spot_check' + id }}\" class=\"form-check-input\"\r\n        [(ngModel)]=\"value\" (ngModelChange)=\"onModelChange()\">\r\n    <label class=\"form-check-label\" for=\"{{ 'spot_check' + id }}\">{{ label }}</label>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return CheckboxComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return CheckboxComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [""]
                },] }
    ];
    CheckboxComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    CheckboxComponent.propDecorators = {
        label: [{ type: core.Input }]
    };

    var CheckboxModule = /** @class */ (function () {
        function CheckboxModule() {
        }
        return CheckboxModule;
    }());
    CheckboxModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [CheckboxComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [CheckboxComponent]
                },] }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var moment$3 = momentNs__namespace;
    var DatepickerParserFormatter$1 = /** @class */ (function (_super) {
        __extends(DatepickerParserFormatter, _super);
        function DatepickerParserFormatter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DatepickerParserFormatter.prototype.parse = function (value) {
            if (!value) {
                return null;
            }
            var date = moment$3.utc(value, 'L', true).toDate();
            return {
                day: date.getDate(),
                month: date.getMonth() + 1,
                year: date.getFullYear()
            };
        }; // from input -> internal model
        DatepickerParserFormatter.prototype.format = function (date) {
            if (!date) {
                return '';
            }
            var dt = new Date(date.year, date.month - 1, date.day);
            var result = moment$3(dt).format('L');
            return result;
        };
        return DatepickerParserFormatter;
    }(ngBootstrap.NgbDateParserFormatter));
    DatepickerParserFormatter$1.decorators = [
        { type: core.Injectable }
    ];

    // tslint:disable-next-line:max-line-length
    var moment$2 = momentNs__namespace;
    var DatepickerComponent = /** @class */ (function () {
        function DatepickerComponent(cd) {
            this.cd = cd;
            this.dateChanged = new core.EventEmitter();
            this.showIcon = true;
            this.inputClasses = ['form-control'];
            this.autoClose = true;
            this.container = null;
            this.innerValue = null;
            this.isDisabled = false;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        DatepickerComponent.prototype.ngOnChanges = function (changes) {
            this.internalMinDate = this.dateStringToNgbDate(this.minDate);
            this.internalMaxDate = this.dateStringToNgbDate(this.maxDate);
            var inputFormat = moment$2().localeData().longDateFormat('L').toLowerCase();
            var min = this.minDate ? moment$2(this.minDate).format('L') : null;
            var max = this.maxDate ? moment$2(this.maxDate).format('L') : null;
            var mask = new Inputmask__default['default']({
                alias: 'datetime',
                inputFormat: inputFormat,
                clearMaskOnLostFocus: false,
                min: min,
                max: max,
                // nullable: false,
                // positionCaretOnClick: 'none',
                // rightAlign: false
            });
            mask.mask(this.input.nativeElement);
        };
        DatepickerComponent.prototype.writeValue = function (value) {
            if (value) {
                this.value = value;
            }
        };
        DatepickerComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        DatepickerComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        DatepickerComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        DatepickerComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        Object.defineProperty(DatepickerComponent.prototype, "value", {
            get: function () {
                return this.ngbDateToDateString(this.innerValue);
            },
            set: function (val) {
                this.innerValue = this.dateStringToNgbDate(val);
                this.propagateChange(val);
                this.cd.markForCheck();
                this.dateChanged.emit(val);
            },
            enumerable: false,
            configurable: true
        });
        DatepickerComponent.prototype.ngOnInit = function () {
            this.internalMinDate = this.dateStringToNgbDate(this.minDate);
            this.internalMaxDate = this.dateStringToNgbDate(this.maxDate);
        };
        DatepickerComponent.prototype.ngAfterViewInit = function () {
            var inputFormat = moment$2().localeData().longDateFormat('L').toLowerCase();
            var min = this.minDate ? moment$2(this.minDate).format('L') : null;
            var max = this.maxDate ? moment$2(this.maxDate).format('L') : null;
            var mask = new Inputmask__default['default']({
                alias: 'datetime',
                inputFormat: inputFormat,
                clearMaskOnLostFocus: false,
                min: min,
                max: max,
                // nullable: false,
                // positionCaretOnClick: 'none',
                // rightAlign: false
            });
            mask.mask(this.input.nativeElement);
        };
        DatepickerComponent.prototype.ngOnDestroy = function () {
            this.cd.detach();
        };
        DatepickerComponent.prototype.onModelChange = function () {
            this.propagateChange(this.value);
            this.onTouched();
            this.dateChanged.emit(this.value);
        };
        DatepickerComponent.prototype.clear = function () {
            this.value = null;
        };
        DatepickerComponent.prototype.onToggle = function () {
            if (!this.isDisabled) {
                this.dp.toggle();
                setTimeout(function () {
                    var el = document.querySelector('ngb-datepicker');
                    if (el) {
                        el.classList.add('ag-custom-component-popup');
                    }
                });
            }
        };
        DatepickerComponent.prototype.ngbDateToDateString = function (ngbDate) {
            if (!ngbDate || typeof ngbDate === 'string') {
                return null;
            }
            else {
                return new Date(ngbDate.year, ngbDate.month - 1, ngbDate.day, 22, 0, 0).toISOString();
            }
        };
        DatepickerComponent.prototype.dateStringToNgbDate = function (dateString) {
            var date = new Date(dateString);
            if (date) {
                return new ngBootstrap.NgbDate(date.getFullYear(), date.getMonth() + 1, date.getDate());
            }
            else {
                return null;
            }
        };
        return DatepickerComponent;
    }());
    DatepickerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-datepicker',
                    template: "<div class=\"input-group\">\r\n  <input\r\n    [ngStyle]=\"{ visibility: hide ? 'hidden' : null }\"\r\n    #dp=\"ngbDatepicker\"\r\n    #input\r\n    type=\"text\"\r\n    id=\"orderDate\"\r\n    [class]=\"inputClasses\"\r\n    name=\"dp\"\r\n    ngbDatepicker\r\n    [(ngModel)]=\"innerValue\"\r\n    (ngModelChange)=\"onModelChange()\"\r\n    [disabled]=\"isDisabled\"\r\n    [container]=\"container\"\r\n    [autoClose]=\"autoClose\"\r\n    [minDate]=\"internalMinDate\"\r\n    [maxDate]=\"internalMaxDate\"\r\n  />\r\n  <div class=\"input-group-text pointer\" *ngIf=\"showIcon\" (click)=\"onToggle()\">\r\n    <i class=\"material-icons\"> calendar_today </i>\r\n  </div>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return DatepickerComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return DatepickerComponent; }),
                            multi: true,
                        }
                    ]
                },] }
    ];
    DatepickerComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    DatepickerComponent.propDecorators = {
        dateChanged: [{ type: core.Output }],
        showIcon: [{ type: core.Input }],
        inputClasses: [{ type: core.Input }],
        autoClose: [{ type: core.Input }],
        container: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        hide: [{ type: core.Input }],
        dp: [{ type: core.ViewChild, args: [ngBootstrap.NgbInputDatepicker, { static: true },] }],
        input: [{ type: core.ViewChild, args: ['input', { static: true },] }]
    };

    var DatepickerModule = /** @class */ (function () {
        function DatepickerModule() {
        }
        return DatepickerModule;
    }());
    DatepickerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [DatepickerComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        ngBootstrap.NgbDatepickerModule
                    ],
                    exports: [DatepickerComponent],
                    providers: [
                        { provide: ngBootstrap.NgbDateParserFormatter, useClass: DatepickerParserFormatter$1 }
                    ]
                },] }
    ];

    var moment$1 = momentNs__namespace;
    var DatepickerParserFormatter = /** @class */ (function (_super) {
        __extends(DatepickerParserFormatter, _super);
        function DatepickerParserFormatter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DatepickerParserFormatter.prototype.parse = function (value) {
            if (!value) {
                return null;
            }
            var date = moment$1.utc(value, 'L', true).toDate();
            return {
                day: date.getDate(),
                month: date.getMonth() + 1,
                year: date.getFullYear()
            };
        }; // from input -> internal model
        DatepickerParserFormatter.prototype.format = function (date) {
            if (!date) {
                return '';
            }
            var dt = new Date(date.year, date.month - 1, date.day);
            var result = moment$1(dt).format('L');
            return result;
        };
        return DatepickerParserFormatter;
    }(ngBootstrap.NgbDateParserFormatter));
    DatepickerParserFormatter.decorators = [
        { type: core.Injectable }
    ];

    var moment = momentNs__namespace;
    var DaterangepickerComponent = /** @class */ (function () {
        function DaterangepickerComponent(cd, formatter) {
            this.cd = cd;
            this.formatter = formatter;
            this.dateChanged = new core.EventEmitter();
            this.inputClasses = ['form-control'];
            this.container = null;
            this.innerValueFrom = null;
            this.innerValueTo = null;
            this.isDisabled = false;
            this.hoveredDate = null;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        DaterangepickerComponent.prototype.ngOnChanges = function (changes) {
            this.internalMinDate = this.dateStringToNgbDate(this.minDate);
            this.internalMaxDate = this.dateStringToNgbDate(this.maxDate);
            var inputFormat = moment().localeData().longDateFormat('L').toLowerCase();
            var min = this.minDate ? moment(this.minDate).format('L') : null;
            var max = this.maxDate ? moment(this.maxDate).format('L') : null;
            var mask = new Inputmask__default['default']({
                alias: 'datetime',
                inputFormat: inputFormat,
                clearMaskOnLostFocus: false,
                min: min,
                max: max,
                // nullable: false,
                // positionCaretOnClick: 'none',
                // rightAlign: false
            });
            mask.mask(this.inputFrom.nativeElement);
            mask.mask(this.inputTo.nativeElement);
        };
        DaterangepickerComponent.prototype.writeValue = function (val) {
            this.innerValueFrom = val ? this.dateStringToNgbDate(val.from) : null;
            this.innerValueTo = val ? this.dateStringToNgbDate(val.to) : null;
            this.cd.markForCheck();
        };
        DaterangepickerComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        DaterangepickerComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        DaterangepickerComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        DaterangepickerComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        DaterangepickerComponent.prototype.onDpToBlur = function () {
            var _a;
            this.innerValueTo = ngBootstrap.NgbDate.from(this.formatter.parse(this.inputTo.nativeElement.value));
            if ((_a = this.innerValueTo) === null || _a === void 0 ? void 0 : _a.before(this.innerValueFrom)) {
                this.innerValueFrom = null;
            }
            this.onDateChanged();
        };
        DaterangepickerComponent.prototype.onDpFromBlur = function () {
            var _a;
            this.innerValueFrom = ngBootstrap.NgbDate.from(this.formatter.parse(this.inputFrom.nativeElement.value));
            if ((_a = this.innerValueTo) === null || _a === void 0 ? void 0 : _a.before(this.innerValueFrom)) {
                this.innerValueTo = null;
            }
            this.onDateChanged();
        };
        Object.defineProperty(DaterangepickerComponent.prototype, "value", {
            get: function () {
                if (this.innerValueFrom && this.innerValueTo) {
                    return {
                        from: this.ngbDateToDateString(this.innerValueFrom),
                        to: this.ngbDateToDateString(this.innerValueTo, true)
                    };
                }
                else {
                    return null;
                }
            },
            enumerable: false,
            configurable: true
        });
        DaterangepickerComponent.prototype.ngOnInit = function () {
            this.internalMinDate = this.dateStringToNgbDate(this.minDate);
            this.internalMaxDate = this.dateStringToNgbDate(this.maxDate);
        };
        DaterangepickerComponent.prototype.ngAfterViewInit = function () {
            var inputFormat = moment().localeData().longDateFormat('L').toLowerCase();
            var min = this.minDate ? moment(this.minDate).format('L') : null;
            var max = this.maxDate ? moment(this.maxDate).format('L') : null;
            var mask = new Inputmask__default['default']({
                alias: 'datetime',
                inputFormat: inputFormat,
                clearMaskOnLostFocus: false,
                min: min,
                max: max,
                // nullable: false,
                // positionCaretOnClick: 'none',
                // rightAlign: false
            });
            mask.mask(this.inputFrom.nativeElement);
            mask.mask(this.inputTo.nativeElement);
        };
        DaterangepickerComponent.prototype.ngOnDestroy = function () {
            this.cd.detach();
        };
        DaterangepickerComponent.prototype.onDateSelection = function (date) {
            if (!this.innerValueFrom && !this.innerValueTo) {
                this.innerValueFrom = date;
            }
            else if (this.innerValueFrom && !this.innerValueTo && date
                && date.after(this.innerValueFrom)) {
                this.innerValueTo = date;
                this.dp.close();
            }
            else {
                this.innerValueTo = null;
                this.innerValueFrom = date;
            }
            this.onDateChanged();
        };
        DaterangepickerComponent.prototype.onDateChanged = function () {
            this.propagateChange(this.value);
            this.onTouched();
            this.dateChanged.emit(this.value);
        };
        DaterangepickerComponent.prototype.onToggle = function () {
            if (!this.isDisabled) {
                this.dp.toggle();
                setTimeout(function () {
                    var el = document.querySelector('ngb-datepicker');
                    if (el) {
                        el.classList.add('ag-custom-component-popup');
                    }
                });
            }
        };
        DaterangepickerComponent.prototype.ngbDateToDateString = function (ngbDate, isDateTo) {
            if (!ngbDate || typeof ngbDate === 'string') {
                return null;
            }
            else {
                var date = new Date(ngbDate.year, ngbDate.month - 1, ngbDate.day);
                if (isDateTo) {
                    date.setHours(23, 59, 59);
                }
                return date.toISOString();
            }
        };
        DaterangepickerComponent.prototype.dateStringToNgbDate = function (dateString) {
            var date = new Date(dateString);
            if (date) {
                return new ngBootstrap.NgbDate(date.getFullYear(), date.getMonth() + 1, date.getDate());
            }
            else {
                return null;
            }
        };
        DaterangepickerComponent.prototype.isHovered = function (date) {
            var hovered = this.innerValueFrom && !this.innerValueTo && this.hoveredDate &&
                date.after(this.innerValueFrom) && date.before(this.hoveredDate);
            return hovered;
        };
        DaterangepickerComponent.prototype.isInside = function (date) {
            return this.innerValueTo && date.after(this.innerValueFrom) && date.before(this.innerValueTo);
        };
        DaterangepickerComponent.prototype.isRange = function (date) {
            return date.equals(this.innerValueFrom) ||
                (this.innerValueTo && date.equals(this.innerValueTo)) || this.isInside(date) || this.isHovered(date);
        };
        return DaterangepickerComponent;
    }());
    DaterangepickerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-daterangepicker',
                    template: "<div class=\"form-group hidden\">\r\n  <div class=\"input-group\">\r\n    <input\r\n      [ngStyle]=\"{ visibility: hide ? 'hidden' : null }\"\r\n      name=\"datepicker\"\r\n      [minDate]=\"internalMinDate\"\r\n      [maxDate]=\"internalMaxDate\"\r\n      class=\"form-control\"\r\n      ngbDatepicker\r\n      #datepicker=\"ngbDatepicker\"\r\n      [autoClose]=\"'outside'\"\r\n      (dateSelect)=\"onDateSelection($event)\"\r\n      [displayMonths]=\"2\"\r\n      [dayTemplate]=\"t\"\r\n      outsideDays=\"hidden\"\r\n      [startDate]=\"innerValueFrom!\"\r\n      [tabIndex]=\"-1\"\r\n      [disabled]=\"isDisabled\"\r\n    />\r\n    <ng-template #t let-date let-focused=\"focused\">\r\n      <span\r\n        class=\"custom-day\"\r\n        [class.focused]=\"focused\"\r\n        [class.range]=\"isRange(date)\"\r\n        [class.faded]=\"isHovered(date) || isInside(date)\"\r\n        (mouseenter)=\"hoveredDate = date\"\r\n        (mouseleave)=\"hoveredDate = null\"\r\n      >\r\n        {{ date.day }}\r\n      </span>\r\n    </ng-template>\r\n  </div>\r\n</div>\r\n<div [ngStyle]=\"{ visibility: hide ? 'hidden' : null }\" class=\"input-group\">\r\n  <input\r\n    #inputFrom\r\n    type=\"text\"\r\n    [class]=\"inputClasses\"\r\n    name=\"dpFrom\"\r\n    [disabled]=\"isDisabled\"\r\n    [value]=\"formatter.format(innerValueFrom)\"\r\n    (blur)=\"onDpFromBlur()\"\r\n  />\r\n  <input\r\n    #inputTo\r\n    type=\"text\"\r\n    [class]=\"inputClasses\"\r\n    name=\"dpTo\"\r\n    [value]=\"formatter.format(innerValueTo)\"\r\n    [disabled]=\"isDisabled\"\r\n    (blur)=\"onDpToBlur()\"\r\n  />\r\n\r\n  <div class=\"input-group-text pointer\" (click)=\"onToggle()\">\r\n    <i class=\"material-icons\"> calendar_today </i>\r\n  </div>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return DaterangepickerComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return DaterangepickerComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [".form-group.hidden{width:0;margin:0;border:none;padding:0;position:absolute}\n"]
                },] }
    ];
    DaterangepickerComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: ngBootstrap.NgbDateParserFormatter }
    ]; };
    DaterangepickerComponent.propDecorators = {
        dateChanged: [{ type: core.Output }],
        inputClasses: [{ type: core.Input }],
        container: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        hide: [{ type: core.Input }],
        dp: [{ type: core.ViewChild, args: [ngBootstrap.NgbInputDatepicker, { static: true },] }],
        inputFrom: [{ type: core.ViewChild, args: ['inputFrom', { static: true },] }],
        inputTo: [{ type: core.ViewChild, args: ['inputTo', { static: true },] }]
    };

    var DaterangepickerModule = /** @class */ (function () {
        function DaterangepickerModule() {
        }
        return DaterangepickerModule;
    }());
    DaterangepickerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [DaterangepickerComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        ngBootstrap.NgbDatepickerModule
                    ], providers: [
                        { provide: ngBootstrap.NgbDateParserFormatter, useClass: DatepickerParserFormatter }
                    ],
                    exports: [DaterangepickerComponent]
                },] }
    ];

    var NumericInputComponent = /** @class */ (function () {
        function NumericInputComponent(cd, locale) {
            this.cd = cd;
            this.locale = locale;
            this.inputClasses = ['form-control'];
            this.digits = '*';
            this.nullable = false;
            this.rightAlign = false;
            this.digitsOptional = true;
            this.prefix = '';
            this.isDisabled = false;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        Object.defineProperty(NumericInputComponent.prototype, "inputValue", {
            get: function () {
                var val = this.input.nativeElement.inputmask.unmaskedvalue();
                if (typeof val === 'string' && val !== '') {
                    // BUG inputmask!
                    return 0;
                }
                if (val === '') {
                    return this.nullable ? null : 0;
                }
                return val;
            },
            enumerable: false,
            configurable: true
        });
        NumericInputComponent.prototype.onInput = function () {
            this.value = this.inputValue;
            this.onModelChange();
        };
        NumericInputComponent.prototype.writeValue = function (value) {
            if (value) {
                this.value = value;
                this.cd.markForCheck();
                // this.input.nativeElement.inputmask.setValue(value);
            }
        };
        NumericInputComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        NumericInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        NumericInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        NumericInputComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        NumericInputComponent.prototype.ngOnInit = function () {
        };
        NumericInputComponent.prototype.ngAfterViewInit = function () {
            var mask = new Inputmask__default['default']({
                alias: 'numeric',
                prefix: this.prefix,
                allowMinus: false,
                allowPlus: false,
                unmaskAsNumber: true,
                radixPoint: common.getLocaleNumberSymbol(this.locale, common.NumberSymbol.Decimal),
                groupSeparator: common.getLocaleNumberSymbol(this.locale, common.NumberSymbol.Group),
                min: this.min,
                max: this.max,
                digits: this.digits,
                clearMaskOnLostFocus: false,
                nullable: this.nullable,
                positionCaretOnClick: 'none',
                rightAlign: this.rightAlign,
                // digitsOptional: this.digitsOptional
                // placeholder: this.nullable ? '' : '0'
            });
            mask.mask(this.input.nativeElement);
        };
        NumericInputComponent.prototype.ngOnDestroy = function () {
            this.cd.detach();
        };
        NumericInputComponent.prototype.focusIn = function () {
            var _this = this;
            window.setTimeout(function () {
                _this.input.nativeElement.focus();
            });
        };
        NumericInputComponent.prototype.onBlur = function () {
            this.onModelChange();
        };
        NumericInputComponent.prototype.selectAllContent = function ($event) {
            this.focusIn();
            setTimeout(function () {
                var tgt = $event.target;
                if (tgt === document.activeElement) {
                    tgt.select();
                }
            }, 50);
        };
        NumericInputComponent.prototype.onModelChange = function () {
            this.propagateChange(this.value);
            this.onTouched();
        };
        return NumericInputComponent;
    }());
    NumericInputComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-numeric-input',
                    template: "<input #input type=\"tel\" [class]=\"inputClasses\" name=\"numericinput\" (input)=\"onInput()\"\r\n    (focus)=\"selectAllContent($event)\" (blur)=\"onBlur()\" [disabled]=\"isDisabled\" [value]=\"value\">\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return NumericInputComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return NumericInputComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [""]
                },] }
    ];
    NumericInputComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: String, decorators: [{ type: core.Inject, args: [core.LOCALE_ID,] }] }
    ]; };
    NumericInputComponent.propDecorators = {
        inputClasses: [{ type: core.Input }],
        digits: [{ type: core.Input }],
        nullable: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        rightAlign: [{ type: core.Input }],
        digitsOptional: [{ type: core.Input }],
        prefix: [{ type: core.Input }],
        input: [{ type: core.ViewChild, args: ['input', { static: true },] }]
    };

    var NumericInputModule = /** @class */ (function () {
        function NumericInputModule() {
        }
        return NumericInputModule;
    }());
    NumericInputModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [NumericInputComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [NumericInputComponent]
                },] }
    ];

    var nextId$1 = 0;
    var RadioComponent = /** @class */ (function () {
        function RadioComponent(cd) {
            this.cd = cd;
            this.id = "chk-" + nextId$1++;
            this.isDisabled = false;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        RadioComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.cd.markForCheck();
        };
        RadioComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        RadioComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        RadioComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        RadioComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        RadioComponent.prototype.ngOnInit = function () {
        };
        RadioComponent.prototype.onModelChange = function ($event) {
            this.propagateChange($event);
            this.onTouched();
        };
        return RadioComponent;
    }());
    RadioComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-radio',
                    template: "<div class=\"form-check\" *ngFor=\"let item of items\">\r\n    <input name=\"spot_radio_{{ id }}\" [disabled]=\"isDisabled\" type=\"radio\" id=\"spot_radio_{{ id }}_{{ item.value }}\"\r\n        class=\"form-check-input\" (ngModelChange)=\"onModelChange($event)\" [value]=\"item.value\" [(ngModel)]=\"value\">\r\n    <label class=\"form-check-label\" for=\"spot_radio_{{ id }}_{{ item.value }}\" translate>{{item.label}}</label>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return RadioComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return RadioComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [":host{display:block}\n"]
                },] }
    ];
    RadioComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    RadioComponent.propDecorators = {
        items: [{ type: core.Input }]
    };

    var RadioModule = /** @class */ (function () {
        function RadioModule() {
        }
        return RadioModule;
    }());
    RadioModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [RadioComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [RadioComponent]
                },] }
    ];

    var nextId = 0;
    var SwitchComponent = /** @class */ (function () {
        function SwitchComponent(cd) {
            this.cd = cd;
            this.value = false;
            this.isDisabled = false;
            this.id = "sw-" + nextId++;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        SwitchComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.cd.markForCheck();
        };
        SwitchComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        SwitchComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        SwitchComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        SwitchComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        SwitchComponent.prototype.ngOnInit = function () {
        };
        SwitchComponent.prototype.onModelChange = function () {
            this.propagateChange(this.value);
            this.onTouched();
        };
        return SwitchComponent;
    }());
    SwitchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-switch',
                    template: "<div class=\"form-check form-switch\">\r\n    <input type=\"checkbox\" [disabled]=\"isDisabled\" class=\"form-check-input\" id=\"spot-sw-{{ id }}\"\r\n        [(ngModel)]=\"value\" (ngModelChange)=\"onModelChange()\">\r\n    <label class=\"form-check-label\" for=\"spot-sw-{{ id }}\">{{ label }} </label>\r\n</div>\r\n",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return SwitchComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return SwitchComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [""]
                },] }
    ];
    SwitchComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SwitchComponent.propDecorators = {
        label: [{ type: core.Input }]
    };

    var SwitchModule = /** @class */ (function () {
        function SwitchModule() {
        }
        return SwitchModule;
    }());
    SwitchModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [SwitchComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [SwitchComponent]
                },] }
    ];

    var FormControlValidatorMessageProvider = /** @class */ (function () {
        function FormControlValidatorMessageProvider() {
            this.defaultValidationMessages = {
                required: 'campo obbligatorio',
                min: 'il valore minimo è _min',
                max: 'il valore massimo è _max',
                pattern: 'formato non valido',
                email: 'formato non valido',
                maxlength: 'il limite massimo di caratteri è _maxlength',
                jsonFormat: 'formato JSON non valido',
                digit: 'è ammessa solo una cifra',
                requiredOneLocalizationItem: 'inserire almeno una lingua'
            };
        }
        FormControlValidatorMessageProvider.prototype.getMessage = function (key, errorInfo) {
            var msg = this.defaultValidationMessages[key] || '';
            if (msg.indexOf('_') > -1 && errorInfo) {
                Object.keys(errorInfo).forEach(function (ph) {
                    msg = msg.replace('_' + ph, errorInfo[ph]);
                });
            }
            return msg;
        };
        return FormControlValidatorMessageProvider;
    }());
    FormControlValidatorMessageProvider.decorators = [
        { type: core.Injectable }
    ];

    var CoreControlValidatorDirective = /** @class */ (function () {
        function CoreControlValidatorDirective(el, renderer, messageProvider) {
            this.el = el;
            this.renderer = renderer;
            this.messageProvider = messageProvider;
            this.showTooltip = false;
            this.addErrorFeedback = true;
            this.errorMessages = {};
            this.submittedForm = false;
            this.markAlways = false;
            this.child = this.renderer.createElement('div');
            this.child.className = 'invalid-feedback';
        }
        Object.defineProperty(CoreControlValidatorDirective.prototype, "htmlElement", {
            get: function () {
                return this.el.nativeElement;
            },
            enumerable: false,
            configurable: true
        });
        CoreControlValidatorDirective.prototype.checkValidity = function () {
            var _this = this;
            if (this.addValidationErrors()) {
                var errors_1 = '';
                var errorInfos_1 = this.getErrors();
                Object.keys(errorInfos_1).forEach(function (key, i) {
                    var errorInfo = errorInfos_1[key];
                    errors_1 += (i > 0 ? '<br>' : '') + _this.messageProvider.getMessage(key, errorInfo);
                });
                if (!this.htmlElement.classList.contains('is-invalid')) {
                    this.htmlElement.classList.add('is-invalid');
                }
                if (this.showTooltip) {
                    this.el.nativeElement.title = errors_1;
                }
                if (this.addErrorFeedback) {
                    this.child.innerHTML = errors_1;
                    this.renderer.appendChild(this.htmlElement.parentElement, this.child);
                }
            }
            else {
                if (this.htmlElement.classList.contains('is-invalid')) {
                    this.htmlElement.classList.remove('is-invalid');
                }
                this.el.nativeElement.title = '';
                if (this.addErrorFeedback && this.child.parentElement) {
                    this.renderer.removeChild(this.htmlElement.parentElement, this.child, false);
                }
            }
        };
        return CoreControlValidatorDirective;
    }());
    CoreControlValidatorDirective.decorators = [
        { type: core.Directive }
    ];
    CoreControlValidatorDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: FormControlValidatorMessageProvider }
    ]; };
    CoreControlValidatorDirective.propDecorators = {
        showTooltip: [{ type: core.Input }],
        addErrorFeedback: [{ type: core.Input }],
        errorMessages: [{ type: core.Input }],
        submittedForm: [{ type: core.Input }],
        markAlways: [{ type: core.Input }]
    };

    var FormControlValidatorDirective = /** @class */ (function (_super) {
        __extends(FormControlValidatorDirective, _super);
        function FormControlValidatorDirective(formControl, el, renderer, messageProvider) {
            var _this = _super.call(this, el, renderer, messageProvider) || this;
            _this.formControl = formControl;
            return _this;
        }
        FormControlValidatorDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.formControl.valueChanges.subscribe(function () {
                _this.checkValidity();
            });
        };
        FormControlValidatorDirective.prototype.ngOnChanges = function () {
            if (this.submittedForm) {
                this.checkValidity();
            }
        };
        FormControlValidatorDirective.prototype.addValidationErrors = function () {
            return this.formControl.invalid && (this.formControl.dirty || this.submittedForm || this.markAlways);
        };
        FormControlValidatorDirective.prototype.getErrors = function () {
            return this.formControl.errors;
        };
        return FormControlValidatorDirective;
    }(CoreControlValidatorDirective));
    FormControlValidatorDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[spotFormControlValidator]'
                },] }
    ];
    FormControlValidatorDirective.ctorParameters = function () { return [
        { type: forms.NgControl },
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: FormControlValidatorMessageProvider }
    ]; };

    var FormControlValidatorModule = /** @class */ (function () {
        function FormControlValidatorModule() {
        }
        return FormControlValidatorModule;
    }());
    FormControlValidatorModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [FormControlValidatorDirective],
                    imports: [
                        common.CommonModule
                    ],
                    providers: [
                        FormControlValidatorMessageProvider
                    ],
                    exports: [
                        FormControlValidatorDirective
                    ]
                },] }
    ];

    var SelectComponent = /** @class */ (function () {
        function SelectComponent(cd) {
            this.cd = cd;
            this.changed = new core.EventEmitter();
            this.isDisabled = false;
            this.propagateChange = function (value) { };
            this.validateFn = function () { };
            this.onTouched = function () { };
        }
        SelectComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.cd.markForCheck();
        };
        SelectComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        SelectComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.cd.markForCheck();
        };
        SelectComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        SelectComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        SelectComponent.prototype.ngOnInit = function () {
        };
        SelectComponent.prototype.onModelChange = function ($event) {
            this.changed.emit($event);
            this.propagateChange($event);
            this.onTouched();
        };
        return SelectComponent;
    }());
    SelectComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-select',
                    template: "<ng-select (ngModelChange)=\"onModelChange($event)\" [clearable]=\"clearable\" [disabled]=\"isDisabled\" [items]=\"items\"\r\n  [bindLabel]=\"bindLabel\" [bindValue]=\"bindValue\" [(ngModel)]=\"value\" [appendTo]=\"appendTo\" [searchable]=\"searchable\"\r\n  [placeholder]=\"placeholder\">\r\n</ng-select>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return SelectComponent; }),
                            multi: true
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return SelectComponent; }),
                            multi: true,
                        }
                    ],
                    styles: [""]
                },] }
    ];
    SelectComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SelectComponent.propDecorators = {
        bindLabel: [{ type: core.Input }],
        bindValue: [{ type: core.Input }],
        appendTo: [{ type: core.Input }],
        clearable: [{ type: core.Input }],
        searchable: [{ type: core.Input }],
        items: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        changed: [{ type: core.Output }]
    };

    var SelectModule = /** @class */ (function () {
        function SelectModule() {
        }
        return SelectModule;
    }());
    SelectModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [SelectComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        ngSelect.NgSelectModule
                    ],
                    exports: [SelectComponent]
                },] }
    ];

    var SliderComponent = /** @class */ (function () {
        function SliderComponent(cd) {
            this.cd = cd;
            this.currentValue = [];
            this.propagateChange = function (value) { };
            this.onTouched = function () { };
            this.validateFn = function () { };
        }
        SliderComponent.prototype.writeValue = function (value) {
            if (value) {
                this.currentValue = value;
            }
            this.cd.markForCheck();
        };
        SliderComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        SliderComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        SliderComponent.prototype.validate = function (control) {
            var res = this.validateFn(control);
            return res;
        };
        SliderComponent.prototype.init = function () {
            var _this = this;
            this.slider = nouislider.create(this.sliderRef.nativeElement, {
                start: this.values,
                connect: true,
                range: {
                    min: this.min,
                    max: this.max
                },
                tooltips: this.tooltips,
                step: this.step,
                format: wNumb__default['default']({
                    decimals: this.decimal
                })
            });
            this.slider.on('change', function () {
                _this.currentValue = _this.slider.get();
                _this.propagateChange(_this.slider.get());
                _this.onTouched();
            });
        };
        SliderComponent.prototype.ngOnInit = function () {
            this.init();
        };
        SliderComponent.prototype.ngOnDestroy = function () {
            this.cd.detach();
        };
        SliderComponent.prototype.ngOnChanges = function (changes) {
        };
        SliderComponent.prototype.onModelChange = function ($event) {
            this.propagateChange($event);
            this.onTouched();
        };
        return SliderComponent;
    }());
    SliderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'spot-slider',
                    template: "<div id=\"slider\" #slider></div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return SliderComponent; }),
                            multi: true,
                        },
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(function () { return SliderComponent; }),
                            multi: true,
                        }
                    ],
                    styles: ["::ng-deep .noUi-connect{background:var(--primary)}\n"]
                },] }
    ];
    SliderComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SliderComponent.propDecorators = {
        sliderRef: [{ type: core.ViewChild, args: ['slider', { static: true },] }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        values: [{ type: core.Input }],
        tooltips: [{ type: core.Input }],
        step: [{ type: core.Input }],
        decimal: [{ type: core.Input }]
    };

    var SliderModule = /** @class */ (function () {
        function SliderModule() {
        }
        return SliderModule;
    }());
    SliderModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [SliderComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [SliderComponent]
                },] }
    ];

    var AngularComponentsModule = /** @class */ (function () {
        function AngularComponentsModule() {
        }
        return AngularComponentsModule;
    }());
    AngularComponentsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        DatepickerModule,
                        NumericInputModule,
                        FormControlValidatorModule,
                        CheckboxModule,
                        RadioModule,
                        SwitchModule,
                        DaterangepickerModule,
                        SelectModule,
                        SliderModule
                    ],
                    exports: [
                        DatepickerModule,
                        NumericInputModule,
                        FormControlValidatorModule,
                        CheckboxModule,
                        RadioModule,
                        SwitchModule,
                        DaterangepickerModule,
                        SelectModule,
                        SliderModule
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of angular-components
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularComponentsModule = AngularComponentsModule;
    exports.CheckboxComponent = CheckboxComponent;
    exports.CheckboxModule = CheckboxModule;
    exports.CoreControlValidatorDirective = CoreControlValidatorDirective;
    exports.DatepickerComponent = DatepickerComponent;
    exports.DatepickerModule = DatepickerModule;
    exports.DaterangepickerComponent = DaterangepickerComponent;
    exports.DaterangepickerModule = DaterangepickerModule;
    exports.FormControlValidatorDirective = FormControlValidatorDirective;
    exports.FormControlValidatorMessageProvider = FormControlValidatorMessageProvider;
    exports.FormControlValidatorModule = FormControlValidatorModule;
    exports.NumericInputComponent = NumericInputComponent;
    exports.NumericInputModule = NumericInputModule;
    exports.RadioComponent = RadioComponent;
    exports.RadioModule = RadioModule;
    exports.SelectComponent = SelectComponent;
    exports.SelectModule = SelectModule;
    exports.SliderComponent = SliderComponent;
    exports.SliderModule = SliderModule;
    exports.SwitchComponent = SwitchComponent;
    exports.SwitchModule = SwitchModule;
    exports.ɵa = DatepickerParserFormatter$1;
    exports.ɵb = DatepickerParserFormatter;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=spotsoftware-angular-components.umd.js.map
