import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { NgbDate, NgbInputDatepicker } from '@ng-bootstrap/ng-bootstrap';
export declare class DatepickerComponent implements OnInit, AfterViewInit, OnDestroy, ControlValueAccessor, OnChanges {
    private cd;
    dateChanged: EventEmitter<string>;
    showIcon: boolean;
    inputClasses: string[];
    autoClose: boolean;
    container: 'body';
    minDate: string;
    maxDate: string;
    hide: boolean;
    internalMinDate: NgbDate;
    internalMaxDate: NgbDate;
    dp: NgbInputDatepicker;
    input: ElementRef;
    innerValue: NgbDate;
    isDisabled: boolean;
    constructor(cd: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    propagateChange: (value: string) => void;
    validateFn: any;
    onTouched: () => void;
    writeValue(value?: string): void;
    registerOnChange(fn: (value: string) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    validate(control: FormControl): any;
    get value(): string;
    set value(val: string);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onModelChange(): void;
    clear(): void;
    onToggle(): void;
    private ngbDateToDateString;
    private dateStringToNgbDate;
}
