import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { NgbDate, NgbDateParserFormatter, NgbInputDatepicker } from '@ng-bootstrap/ng-bootstrap';
interface DateRangeValue {
    from: string;
    to: string;
}
export declare class DaterangepickerComponent implements OnInit, AfterViewInit, OnDestroy, ControlValueAccessor, OnChanges {
    private cd;
    formatter: NgbDateParserFormatter;
    dateChanged: EventEmitter<DateRangeValue>;
    inputClasses: string[];
    container: 'body';
    minDate: string;
    maxDate: string;
    hide: boolean;
    internalMinDate: NgbDate;
    internalMaxDate: NgbDate;
    dp: NgbInputDatepicker;
    inputFrom: ElementRef;
    inputTo: ElementRef;
    innerValueFrom: NgbDate;
    innerValueTo: NgbDate;
    isDisabled: boolean;
    hoveredDate: NgbDate | null;
    constructor(cd: ChangeDetectorRef, formatter: NgbDateParserFormatter);
    ngOnChanges(changes: SimpleChanges): void;
    propagateChange: (value: DateRangeValue) => void;
    validateFn: any;
    onTouched: () => void;
    writeValue(val?: DateRangeValue): void;
    registerOnChange(fn: (value: DateRangeValue) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    validate(control: FormControl): any;
    onDpToBlur(): void;
    onDpFromBlur(): void;
    get value(): {
        from: string;
        to: string;
    };
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onDateSelection(date: NgbDate): void;
    onDateChanged(): void;
    onToggle(): void;
    private ngbDateToDateString;
    private dateStringToNgbDate;
    isHovered(date: NgbDate): boolean;
    isInside(date: NgbDate): boolean;
    isRange(date: NgbDate): boolean;
}
export {};
