import { OnInit, OnDestroy, OnChanges, ElementRef, ChangeDetectorRef, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { noUiSlider } from 'nouislider';
export declare class SliderComponent implements OnInit, OnDestroy, ControlValueAccessor, OnChanges {
    private cd;
    sliderRef: ElementRef;
    min: number;
    max: number;
    values: number[];
    tooltips: boolean;
    step: number;
    decimal: number;
    slider: noUiSlider;
    currentValue: string | string[];
    constructor(cd: ChangeDetectorRef);
    propagateChange: (value: string | string[]) => void;
    onTouched: () => void;
    validateFn: any;
    writeValue(value?: string[]): void;
    registerOnChange(fn: (value: string[]) => void): void;
    registerOnTouched(fn: () => void): void;
    validate(control: FormControl): any;
    init(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onModelChange($event: any): void;
}
